var express = require('express');
var path = require('path');
var app = express();

// 设置pug引擎
app.set('views', path.join(__dirname, 'views'));
app.set('view engine', 'pug');

// 解析传参
app.use(express.json());
app.use(express.urlencoded({ extended: false }));


app.all('*', function (req, res, next) {
res.header("Access-Control-Allow-Origin", "*");
res.header("Access-Control-Allow-Headers", "X-Requested-With");
res.header("Access-Control-Allow-Methods", "PUT,POST,GET,DELETE,OPTIONS");
res.header("X-Powered-By", ' 3.2.1');
res.header("Content-Type", "application/json;charset=utf-8");
next();
});


/**
 * config
 *      ip:
 *      prot:
 *      funclist: function list
 */

exports.start = (config) => {
    const {gate_list, game_list, pay_success_cb} = config.funclist;	
	
	if (gate_list) {
		for (const reg in gate_list) {
			if (gate_list.hasOwnProperty(reg)) {
				const func = gate_list[reg];
				app.get(`/${reg}`, func);
				app.post(`/${reg}`, func);
			}
		}
	}
	
	if (game_list) {
		for (const reg in game_list) {
			if (game_list.hasOwnProperty(reg)) {
				const func = game_list[reg];
				app.get(`/${reg}`, func);
				app.post(`/${reg}`, func);
			}
		}
	}
	
	if (pay_success_cb) {
		app.post('/pay_success_cb', (req, res) => {
			pay_success_cb(req, res);
		}); 
	}
    
    app.listen(config.port);
}

exports.app = app;
